// jshint esversion: 6	
	import * as THREE from 'three';

	// sextupole booster
	export function quadrupolefermi(length=450) {
		const QuadrupoleContiner = new THREE.Object3D();
		const QuadrupoleMaster = new THREE.Object3D();
		
		const dmaterial = new THREE.MeshLambertMaterial({color: 0xFF0000});
		
		// support alto
		const geometry_1 = new THREE.BoxGeometry(length, 100, 200);
		const dmesh_1 = new THREE.Mesh(geometry_1, dmaterial);
		dmesh_1.position.set(0, 324, 0);
		QuadrupoleMaster.add(dmesh_1);
		
		// support side destra
		const dmesh_2 = new THREE.Mesh(geometry_1, dmaterial);
		dmesh_2.position.set(0, 280, -162);
		dmesh_2.rotateX(-Math.PI / 6);
		QuadrupoleMaster.add(dmesh_2);

		// support side sinistra 
		const dmesh_3 = new THREE.Mesh(geometry_1, dmaterial);
		dmesh_3.position.set(0, -280, -162);
		dmesh_3.rotateX(-Math.PI / -6);
		QuadrupoleMaster.add(dmesh_3);		
		
		const geometry4 = new THREE.BoxGeometry(length-30, 120, 50);
		const dmesh4 = new THREE.Mesh(geometry4, dmaterial);
		dmesh4.position.set(0, 140, 0);
		QuadrupoleMaster.add(dmesh4);
		
		
		// coil
		const coilmaterial = new THREE.MeshLambertMaterial({color: 0xc08000});
		const textureLoader = new THREE.TextureLoader();
		const texture = textureLoader.load('./components/coil_texture.png');
		texture.wrapS = texture.wrapT = THREE.RepeatWrapping;
		texture.repeat.set(5, 5);
		const d6geometry = new THREE.CylinderGeometry(250 /*radiusTop*/, 250 /*radiusBottom*/, 80 /*height*/, 25 /*radialSegments*/, 4 /*heightSegments*/, false /*openEnded*/,Math.PI * 1.5 /*thetaStart*/, Math.PI * 2 /*thetaLength*/);
		const material6 = new THREE.MeshBasicMaterial({ map: texture });
		const materialside6 = new THREE.MeshBasicMaterial({color: 0xcd7f32});
		const materials6 = [material6, materialside6, materialside6];		
		const d6mesh = new THREE.Mesh(d6geometry, materials6);
		d6mesh.position.set(0, 230, 0);
		d6mesh.rotateX(Math.PI * 1.50);
		d6mesh.rotateY(Math.PI * 1.50);
		d6mesh.rotateZ(Math.PI * 1.50);
		QuadrupoleMaster.add(d6mesh);
		
		for (let i=1; i<4; i++) {
			const Quadrupole2 = QuadrupoleMaster.clone();
			Quadrupole2.rotateX(-Math.PI / 2*i);
			QuadrupoleContiner.add(Quadrupole2);
		}
		
		QuadrupoleContiner.add(QuadrupoleMaster);
		// QuadrupoleContiner.rotateX(Math.PI * 1.25);
		QuadrupoleContiner.rotateY(Math.PI * 1.00);
		QuadrupoleContiner.rotateZ(Math.PI * 1.00);

		return QuadrupoleContiner;
	}
